'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'This simple 3d engine demonstrates the following concepts described in
'the Intro to 3d series for QB Cult Magazine:
'
'*  Creating a world by means of world coordinates.
'*  Conversion of world coordinates into camera/eye/viewer coordinates.
'*  Conversion of camera coordinates into screen coordinates.
'*  Rotation.
'*  The effect of 'walking' in the 3d world.
'
'Okay, one thing I must say...this engine demonstrates VERY bad programming.
'Many things could be fixed in this engine to make the code smaller and
'faster, however, I wrote this program with the intention of it being as easy
'to understand as possible.
'
'Basically, in this 3d engine all you do is walk around on the piece of floor
'in 3d space. Nothing spectacular, but it does serve as a good demonstration
'of implementing what you know about 3d. A VERY IMPORTANT thing which has to
'be mentioned is that this proggy does not check if world coordinates are
'in line with or behind the camera (aka eye, viewer). It is easy to add to
'the engine...consider adding this as a homework assignment! Note that the
'problem with this engine not doing these checks is that sometimes it will
'do strange things or error out...you'll see what I mean! ^_^ To avoid
'getting these errors, just don't walk off the piece of floor.
'
'To 'walk' around on the block of floor all you have to do is use the numeric
'keypad. 4 is left, 6 is right, 8 is forward, 2 is backward. Simple! Keys 7
'and 9 also do something cool...and also try out Q and A. For the Q and A keys
'to work you must have CAPS LOCK on! As would be expected, the ESC (escape)
'key let's you...ahem...escape from the program ^_^
'
'Have fun with this program and your new knowledge! ^_^
'
'- Matthew River Knight
'
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'Fire up graphics mode 7, using pages 0 and 1.
SCREEN 7, , 0, 1

'Screen resolution.
MaxX = 320: MaxY = 200

'The color of the 3d object.
C = 2

'Eye position.
EyeX = 0: EyeY = 40: EyeZ = 80

'World coordinates.
W0X = 30: W0Y = 0: W0Z = 0
W1X = -30: W1Y = 0: W1Z = 0
W2X = 30: W2Y = 0: W2Z = -80
W3X = -30: W3Y = 0: W3Z = -80

'Draw the object prior to rotation and movement of the player.
GOSUB DrawObject

'Main program loop.
DO
  K$ = INKEY$
  IF K$ = "7" THEN Angle = 5 * .017453: GOSUB Rotate
  IF K$ = "9" THEN Angle = -5 * .017453: GOSUB Rotate
  IF K$ = "Q" THEN Angle = 5 * .017453: GOSUB Rotate
  IF K$ = "A" THEN Angle = -5 * .017453: GOSUB Rotate
  IF K$ = "6" THEN Angle = 5 * .017453: GOSUB Rotate
  IF K$ = "4" THEN Angle = -5 * .017453: GOSUB Rotate
  IF K$ = "8" THEN W0Z = W0Z + 2: W1Z = W1Z + 2: W2Z = W2Z + 2: W3Z = W3Z + 2: GOSUB DrawObject
  IF K$ = "2" THEN W0Z = W0Z - 2: W1Z = W1Z - 2: W2Z = W2Z - 2: W3Z = W3Z - 2: GOSUB DrawObject
  IF K$ = CHR$(27) THEN END
LOOP

Rotate:  'Initiate rotation of the object.
OldX = W0X: OldY = W0Y: OldZ = W0Z: GOSUB Formulae: W0X = X: W0Y = Y: W0Z = Z
OldX = W1X: OldY = W1Y: OldZ = W1Z: GOSUB Formulae: W1X = X: W1Y = Y: W1Z = Z
OldX = W2X: OldY = W2Y: OldZ = W2Z: GOSUB Formulae: W2X = X: W2Y = Y: W2Z = Z
OldX = W3X: OldY = W3Y: OldZ = W3Z: GOSUB Formulae: W3X = X: W3Y = Y: W3Z = Z
GOSUB DrawObject
RETURN

Formulae:  'Determine and use the required formula for rotation.
IF K$ = "Q" OR K$ = "A" THEN
  X = OldX
  Y = (SIN(Angle) * OldZ) + (COS(Angle) * OldY)
  Z = (COS(Angle) * OldZ) - (SIN(Angle) * OldY)
END IF
IF K$ = "4" OR K$ = "6" THEN
  X = (COS(Angle) * OldX) - (SIN(Angle) * OldZ)
  Y = OldY
  Z = (SIN(Angle) * OldX) + (COS(Angle) * OldZ)
END IF
IF K$ = "7" OR K$ = "9" THEN
  X = (COS(Angle) * OldX) + (SIN(Angle) * OldY)
  Y = (COS(Angle) * OldY) - (SIN(Angle) * OldX)
  Z = OldZ
END IF
RETURN

DrawObject:  'Draws the object...I'm sure you already guessed this! ^_^
'Calculation of eye coordinates.
E0X = W0X - EyeX: E0Y = W0Y - EyeY: E0Z = W0Z - EyeZ
E1X = W1X - EyeX: E1Y = W1Y - EyeY: E1Z = W1Z - EyeZ
E2X = W2X - EyeX: E2Y = W2Y - EyeY: E2Z = W2Z - EyeZ
E3X = W3X - EyeX: E3Y = W3Y - EyeY: E3Z = W3Z - EyeZ

'Transformation of eye coordinates into screen coordinates.
S0X = (E0X / E0Z) * MaxX + MaxX / 2: S0Y = (E0Y / E0Z) * MaxY + MaxY / 2
S1X = (E1X / E1Z) * MaxX + MaxX / 2: S1Y = (E1Y / E1Z) * MaxY + MaxY / 2
S2X = (E2X / E2Z) * MaxX + MaxX / 2: S2Y = (E2Y / E2Z) * MaxY + MaxY / 2
S3X = (E3X / E3Z) * MaxX + MaxX / 2: S3Y = (E3Y / E3Z) * MaxY + MaxY / 2

CLS  'Hmmm...now what does this line do?! ^_^

'Just PRINT the values of various variables. I personally find this info
'very usefull.
PRINT "Eye(X;Y;Z):"; EyeX; ";"; EyeY; ";"; EyeZ
PRINT
PRINT "W0(X;Y;Z):"; W0X; ";"; W0Y; ";"; W0Z
PRINT "W1(X;Y;Z):"; W1X; ";"; W1Y; ";"; W1Z
PRINT "W2(X;Y;Z):"; W2X; ";"; W2Y; ";"; W2Z
PRINT "W3(X;Y;Z):"; W3X; ";"; W3Y; ";"; W3Z
PRINT
PRINT "E0(X;Y;Z):"; E0X; ";"; E0Y; ";"; E0Z
PRINT "E1(X;Y;Z):"; E1X; ";"; E1Y; ";"; E1Z
PRINT "E2(X;Y;Z):"; E2X; ";"; E2Y; ";"; E2Z
PRINT "E3(X;Y;Z):"; E3X; ";"; E3Y; ";"; E3Z
PRINT
PRINT "S0(X;Y;Z):"; S0X; ";"; S0Y; ";"; S0Z
PRINT "S1(X;Y;Z):"; S1X; ";"; S1Y; ";"; S1Z
PRINT "S2(X;Y;Z):"; S2X; ";"; S2Y; ";"; S2Z
PRINT "S3(X;Y;Z):"; S3X; ";"; S3Y; ";"; S3Z

'The actual code to draw the object.
LINE (S0X, S0Y)-(S1X, S1Y), C
LINE (S0X, S0Y)-(S2X, S2Y), C
LINE (S0X, S0Y)-(S3X, S3Y), C
LINE (S1X, S1Y)-(S2X, S2Y), C
LINE (S1X, S1Y)-(S3X, S3Y), C
LINE (S2X, S2Y)-(S3X, S3Y), C

'Wait for vertical retrace to reduce flicker. Don't worry about what this
'means...it's kinda technical...just use it! ;)
WAIT &H3DA, 8

PCOPY 0, 1
RETURN
'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

