DECLARE SUB Addheader (mode%)
DECLARE SUB Addasmroutines ()
DECLARE SUB Keyword.LOCATE ()
DECLARE SUB Keyword.CLS ()
DECLARE SUB Keyword.END ()
DECLARE SUB Keyword.WAITKEY ()
DECLARE SUB Parser.Math ()
DECLARE SUB ShowError (Errornumber%)
DECLARE FUNCTION Getfullword$ ()
DECLARE FUNCTION Getword$ ()
DECLARE FUNCTION Getchar$ ()

' ---------- COMPILER.BAS
'
' Part of the compiler tutorial by Gabriel Fernandez
' Gabfm@hotmail.com

DIM SHARED text$, linen&
DIM SHARED GetCharpos AS INTEGER   ' This variable is for GetWord$ and
                                   ' Getfullword$ functions

CONST Add = 1, Subs = 2, Mul = 3, Div = 4   ' For the Math Parser

Inputfile$ = "test.bas"
outputfile$ = "test.asm"

CLS

OPEN Inputfile$ FOR INPUT AS #1
OPEN outputfile$ FOR OUTPUT AS #2

Addheader 1

DO WHILE NOT EOF(1)
  LINE INPUT #1, text$
  PRINT #2, "; " + text$
  linen& = linen& + 1
  GetCharpos = 0
  Keyword$ = Getword$

  SELECT CASE UCASE$(Keyword$)  ' Keywords list
    CASE "CLS": Keyword.CLS
    CASE "END": Keyword.END
    CASE "LOCATE": Keyword.LOCATE
    CASE "WAITKEY": Keyword.WAITKEY
  END SELECT

LOOP

Addasmroutines    ' Add the asm routines
Addheader 2
CLOSE
END

SUB Addasmroutines
 
  ' Cls routine
  PRINT #2, "CLS:"
  PRINT #2, "  PUSH ES"
  PRINT #2, "    mov ax, 0B800h"
  PRINT #2, "    mov es, ax"
  PRINT #2, "    mov di, 0"
  PRINT #2, "    mov cx, 2000"
  PRINT #2, "    mov ax, 0"
  PRINT #2, "    REP STOSW"
  PRINT #2, "  POP ES"
  PRINT #2, "RET"

END SUB

SUB Addheader (mode%)

SELECT CASE mode%
CASE 1
  PRINT #2, "[BITS 16]"
  PRINT #2, "[section .code]"
CASE 2
  PRINT #2, "[section .data]"
  PRINT #2, "Textx DW 1"
  PRINT #2, "Texty DW 1"
END SELECT

END SUB

FUNCTION Getchar$

GetCharpos = GetCharpos + 1
IF GetCharpos > LEN(text$) THEN Getchar$ = "eof": EXIT FUNCTION

a$ = MID$(text$, GetCharpos, 1)
IF a$ = "'" THEN Getchar$ = "eof": EXIT FUNCTION

Getchar$ = a$

END FUNCTION

FUNCTION Getfullword$
b$ = ""

DO
  a$ = Getchar$
  IF a$ = "," OR a$ = "eof" THEN Getfullword$ = b$: EXIT FUNCTION
  b$ = b$ + a$
LOOP

END FUNCTION

FUNCTION Getword$

a$ = " "
DO WHILE a$ = " " OR a$ = CHR$(9)
  a$ = Getchar$
  IF a$ = "eof" THEN Getword$ = "eof": EXIT FUNCTION
LOOP

GetCharpos = GetCharpos - 1
b$ = ""

DO
  a$ = Getchar$
  IF a$ = " " OR a$ = "eof" OR a$ = CHR$(9) THEN Getword$ = b$: EXIT FUNCTION
  b$ = b$ + a$
LOOP

END FUNCTION

SUB Keyword.CLS
  PRINT #2, "CALL CLS"
END SUB

SUB Keyword.END
  PRINT #2, "MOV AX, 4C00h"
  PRINT #2, "INT 21h"
END SUB

SUB Keyword.LOCATE
 parameter1$ = Getfullword$
 parameter2$ = Getfullword$

 ' - Parse first Parameter
 text$ = parameter1$
 GetCharpos = 0
 Parser.Math
   PRINT #2, "MOV [Textx], ax"

 ' - Parse second Parameter
 text$ = parameter2$
 GetCharpos = 0
 Parser.Math
   PRINT #2, "MOV [Texty], ax"
END SUB

SUB Keyword.WAITKEY
  PRINT #2, "XOR AX, AX"
  PRINT #2, "INT 16h"
END SUB

DEFINT A-Z
SUB Parser.Math

a$ = Getword$
PRINT #2, "MOV AX," + a$
CurrentOp = 1

DO
 a$ = Getword$

 IF a$ = "eof" THEN EXIT SUB
 IF CurrentOp = 1 THEN
   CurrentOp = 2
   SELECT CASE a$
     CASE "+": MathOp = Add:  GOTO label1
     CASE "-": MathOp = Subs: GOTO label1
     CASE "/": MathOp = Div:  GOTO label1
     CASE "*": MathOp = Mul:  GOTO label1
   END SELECT
   ShowError 3
 ELSE
   SELECT CASE MathOp
     CASE Add:  PRINT #2, "ADD AX, " + a$
     CASE Subs: PRINT #2, "SUB AX, " + a$
     CASE Mul:  PRINT #2, "MOV DX, 0"
                PRINT #2, "MOV BX, " + a$
                PRINT #2, "MUL BX"
     CASE Div:  PRINT #2, "MOV DX, 0"
                PRINT #2, "MOV BX, " + a$
                PRINT #2, "DIV BX"
   END SELECT
   CurrentOp = 1
 END IF

label1:
LOOP

END SUB

SUB ShowError (Errornumber)
  BEEP
  PRINT "An error was found in the line: ", linen&

  SELECT CASE Errornumber
    CASE 1: PRINT "Argument-count mismatch"
    CASE 2: PRINT "Unkown command"
    CASE 3: PRINT "Invalid Operation"
  END SELECT
 
  PRINT
  PRINT "Text: " + text$

  END
END SUB

